#ifndef ECDSWEDA_H
#define ECDSWEDA_H

#include <QLibrary>
#include <windows.h>

class EcdSweda
{
private:
    QLibrary *library;

public:
    EcdSweda();
    virtual ~EcdSweda();

    int bInitialize(HWND handle);
    void vGetMsgWinReceiveDataTC(LPUINT msg);
    int bTerminate();
    int bConnect(int &port, QString &ip);
    int bDisconnect(int &port, QString &ip);
    int bReceiveBarcode(int &port, QString &ip, QString &barcode);


};

#endif // ECDSWEDA_H
