unit uPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IniFiles, DB,  ComCtrls, DBCtrls, Grids, DBGrids,  jpeg, Mask, DBTables;

type
  TfrmPrincipal = class(TForm)
    DBISAMTable1: TTable;
    DBISAMTable1Codigo: TStringField;
    DBISAMTable1Nome: TStringField;
    DBISAMTable1Preco: TCurrencyField;
    DataSource1: TDataSource;
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Button2: TButton;
    TabSheet2: TTabSheet;
    DBNavigator1: TDBNavigator;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    Button3: TButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    Label4: TLabel;
    Label7: TLabel;
    txtLinha1: TEdit;
    txtLinha2: TEdit;
    GroupBox6: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    txtLinha3: TEdit;
    txtLinha4: TEdit;
    Label10: TLabel;
    txtTerminal: TEdit;
    Label11: TLabel;
    txtServidor: TEdit;
    Label12: TLabel;
    txtNetmask: TEdit;
    Label13: TLabel;
    txtExibicao: TEdit;
    Label14: TLabel;
    txtTerminalSelecionado: TEdit;
    Label15: TLabel;
    btnDesconectar: TButton;
    btnCapturar: TButton;
    btnEnviar: TButton;
    GroupBox7: TGroupBox;
    Label16: TLabel;
    Label17: TLabel;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    Label5: TLabel;
    Memo3: TMemo;
    Memo4: TMemo;
    lblCodeTerminal: TLabel;
    lblCodigo: TLabel;
    listTerminais: TListBox;
    GroupBoxGetString: TGroupBox;
    MemoGetString: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure WndProc(var Messagem : TMessage); override;
    procedure btnDesconectarClick(Sender: TObject);
    procedure btnEnviarClick(Sender: TObject);
    procedure btnCapturarClick(Sender: TObject);
    procedure listTerminaisClick(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
  end;


type stRegistroProd = record
  sCodeBar: string;
  sTitulo: string;
  fPreco:   Currency;
end;

type stRegistroCard = record
  sCardCode: string;
  sLine1: string;
  sLine2: string;
end;

var
  frmPrincipal: TfrmPrincipal;
  mensagem:uint;
implementation

uses uLista,uIntSC50X;

{$R *.dfm}

procedure TfrmPrincipal.Button1Click(Sender: TObject);
begin
     if frmPrincipal.Tag > 0 then
        bShowWindow;

     Application.MessageBox('A funo "bShowWindow" est contida na DLL somente para manter compatibilidade com verses anteriores.'+ #13+'Onde esta funo sempre retorn "True".','Saci - Sweda', MB_OK + MB_ICONINFORMATION);
end;

procedure TfrmPrincipal.Button2Click(Sender: TObject);
begin
     if bInitialize(frmPrincipal.Handle) then
     begin
          vGetMsgWinReceiveDataTC(mensagem);
          Application.MessageBox('Servidor inicializado.','Sweda - ECD', MB_OK + MB_ICONINFORMATION);
          frmPrincipal.Tag := 1;
     end;
end;

procedure TfrmPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
if frmPrincipal.Tag > 0 then
     bTerminate;
end;

procedure TfrmPrincipal.FormCreate(Sender: TObject);
begin
     PageControl1.ActivePageIndex := 0;
     DBISAMTable1.Close;
     DBISAMTable1.DatabaseName := ExtractFilePath(Application.ExeName);
     if not DBISAMTable1.Exists then
        DBISAMTable1.CreateTable;
     DBISAMTable1.Open;
end;

procedure TfrmPrincipal.Button3Click(Sender: TObject);
begin
     frmLista.ShowModal;
end;

procedure TfrmPrincipal.WndProc(var Messagem : TMessage);
var
  NumIP: string;
  htonlIP: DWORD;
  IP: stAddress;
  texto: array[0..255] of char ;
  barcode: array[0..255] of char ;
  lpznLine1:array[0..30] of char; // No Display so 2 linhas de 20 colunas
  lpznLine2:array[0..30] of char;
  v_i: integer;
begin
 // Edit1.Text := IntToStr(Message.Msg);

  if (Messagem.Msg = mensagem) then begin
    if(bConnect(IP)) then begin
        Inet_NtoA(IP.Ip,texto);
        NumIP := StrPas(texto);
        htonlIP:= Inet_Addr(texto);
        memo4.lines.add(formatdatetime('hh:mm:ss', now) + ' -> IP: '+ NumIP);
        Memo4.lines.add('               -> IP (htonl): '+ inttostr(htonlIP));

        listTerminais.Items.Add(NumIP);

    end
    else
    if(bDisconnect(IP)) then begin
        Inet_NtoA(IP.Ip,texto);
        NumIP := StrPas(texto);
        htonlIP:= Inet_Addr(texto);
        memo3.lines.add(formatdatetime('hh:mm:ss', now) + ' -> IP: '+ NumIP);
        Memo3.lines.add('               -> IP (htonl): '+ inttostr(htonlIP));

        try
        for v_i := 0 to listTerminais.Items.Count-1 do begin
            if listTerminais.Items[v_i] = NumIP then
                listTerminais.Items.Delete(v_i);
        end;
        except
        end;
        
        // Procura qual socket se desconecta dentro da lista dos conectados
     end
     else
    if (bReceiveBarcode(IP,barcode)) then begin
        lblCodigo.Caption:= barcode;
        Inet_NtoA(IP.Ip,texto);
        NumIP := StrPas(texto);
        lblCodeTerminal.Caption:= NumIP;


      if (DBISAMTable1.FindKey([barcode])) then
      begin
         // Ele envia o Nome e Preco do Produto
         StrPCopy(lpznLine1,DBISAMTable1Nome.Value);
         StrPCopy(lpznLine2,FloatToStrF(DBISAMTable1Preco.Value,ffCurrency,18,2));

               bSendProdPriceTC50X(IP,lpznLine1,lpznLine2);
         //end

      end
      else
         bSendProdNotFound(IP);  //Envia uma mensagem de produto no cadastrado
    end

  end;
  inherited WndProc(Messagem);

end;

procedure TfrmPrincipal.btnDesconectarClick(Sender: TObject);
  var IP: stAddress;
  msg:string;
begin

        IP.Ip := Inet_Addr(Pchar(txtTerminalSelecionado.Text));

        if (CloseTerminal(IP)) then  begin
                msg:=  'O Terminal de IP ('+ txtTerminalSelecionado.Text + ') foi desconectado com sucesso.';
                Application.MessageBox(Pchar(msg), 'Sweda - ECD', MB_OK + MB_ICONINFORMATION);
        end
        else begin
                msg:=  'Erro, o Terminal de IP (' + txtTerminalSelecionado.Text + ') no est conectado ou no existe.';
                Application.MessageBox(Pchar(msg), 'Sweda - ECD', MB_OK + MB_ICONERROR);
        end;
                end;
procedure TfrmPrincipal.btnEnviarClick(Sender: TObject);
var terminal, servidor, netmask, exibicao, linha1, linha2, linha3, linha4, IpAtual:pchar;
msg:string;
ret: boolean;

begin

        terminal := pchar(txtTerminal.Text);
        servidor := pchar(txtServidor.Text);
        netmask := pchar(txtNetmask.Text);
        exibicao := pchar(txtExibicao.Text);
        linha1 := pchar(txtLinha1.Text);
        linha2 := pchar(txtLinha2.Text);
        linha3 := pchar(txtLinha3.Text);
        linha4 := pchar(txtLinha4.Text);
        IpAtual := pchar(txtTerminalSelecionado.Text);
        MemoGetString.Text:='';

        ret := SendConfiguration(IpAtual, terminal, servidor, netmask, linha1, linha2, linha3, linha4, exibicao);
            
        if (ret)  then begin
                msg:=  'Configurao enviada com sucesso para o Terminal de IP: '+ IpAtual + '.';
                Application.MessageBox(Pchar(msg), 'Sweda - ECD', MB_OK + MB_ICONINFORMATION);

        end
        else begin
                msg:=  'Erro ao enviar a Configurao para o Terminal de IP: ' + IpAtual + '.';
                Application.MessageBox(Pchar(msg), 'Sweda - ECD', MB_OK + MB_IconError);
        end;

        txtTerminalSelecionado.Text:='';
end;

procedure TfrmPrincipal.btnCapturarClick(Sender: TObject);
var
    terminal:array[0..16] of char;
    servidor:array[0..16] of char;
    netmask:array[0..16] of char;
    exibicao:array[0..2] of char;
    linha1: array[0..40] of char;
    linha2: array[0..40] of char;
    linha3: array[0..40] of char;
    linha4: array[0..40] of char;
    GetConfigString: array[0..512] of char;
    IpAtual: pchar;

    msg:string;
    ret: boolean;
begin
   IpAtual := pchar(txtTerminalSelecionado.Text);
   MemoGetString.Text:='';
   ret := GetConfigurationNew(IpAtual, terminal, servidor, netmask, linha1, linha2, linha3, linha4, exibicao, nil,nil,nil,nil,nil);
   if (ret)  then begin
        txtTerminal.Text:=terminal;
        txtServidor.Text:=servidor;
        txtNetmask.Text:=netmask;
        txtExibicao.Text:=exibicao;
        txtLinha1.Text:=linha1;
        txtLinha2.Text:=linha2;
        txtLinha3.Text:=linha3;
        txtLinha4.Text:=linha4;
        txtTerminalSelecionado.Text:='';
        msg:=  'Captura dos dados do Terminal de IP (' + IpAtual + ') realizada com sucesso.';
        Application.MessageBox(Pchar(msg), 'Sweda - ECD', MB_OK + MB_ICONINFORMATION);

        ret := GetConfiguration(IpAtual, GetConfigString);
        if (ret) then
               MemoGetString.text:= GetConfigString;



   end
   else begin
        msg:=  'Erro ao capturar os dados do Terminal de IP : ' + IpAtual + '.';
        Application.MessageBox(Pchar(msg), 'Sweda - ECD', MB_OK + MB_IconError);
        txtTerminal.Text:='';
        txtServidor.Text:='';
        txtNetmask.Text:='';
        txtExibicao.Text:='';
        txtLinha1.Text:='';
        txtLinha2.Text:='';
        txtLinha3.Text:='';
        txtLinha4.Text:='';
        txtTerminalSelecionado.Text:='';
   end;
end;

procedure TfrmPrincipal.listTerminaisClick(Sender: TObject);
begin
      txtTerminalSelecionado.Text := listTerminais.Items[listTerminais.ItemIndex];
end;



end.
